/************************************************************
 * $Id: parameters.c 125 1999-04-29 16:46:30Z clerger $
 * Copyright (C) 1997 Eric de la Clergerie
 * ------------------------------------------------------------
 *
 * Parameters  -- DyALog parameter files
 *
 * ------------------------------------------------------------
 * Description
 *
 * ------------------------------------------------------------
 */

#include <string.h>

#include "config.h"
#include "bigloo.h"
#include "fol.h"

/**********************************************************************
 * Some tools
 **********************************************************************/

char *
safe_string_copy(s, s1 )
     char *s,*s1;
{
  return strcpy((char *) GC_MALLOC_ATOMIC(strlen(s1)+1),s1);
}

/**********************************************************************
 * About this software
 **********************************************************************/

const char *_dyalog_package  = __DYALOG_PACKAGE_PATH__;

const char *_dyalog_name     = "DyALog (alpha 5)";
const char *_dyalog_author   = "Eric de la Clergerie";
const char *_dyalog_email    = "Eric.Clergerie@inria.fr";

/**********************************************************************
 * High Level Parameters
 **********************************************************************/

fol_t  _dyalog_argv         = FOLNIL;

/**********************************************************************
 * Low Level Parameters
 **********************************************************************/


int    _dyalog_initialization_stamp = 0;

obj_t  _dyalog_callret_viewer = BNIL;

char *  _dyalog_tfs_file;

int     verbose_level = 0;



